diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/model/animation-interface.h ns-3.38/src/netanim/model/animation-interface.h
--- ns-3.37/src/netanim/model/animation-interface.h	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/model/animation-interface.h	2023-03-16 20:54:23.804869200 -0700
@@ -97,11 +97,11 @@
     /**
      * Counter Types
      */
-    typedef enum
+    enum CounterType
     {
         UINT32_COUNTER,
         DOUBLE_COUNTER
-    } CounterType;
+    };
 
     /**
      * \brief typedef for WriteCallBack used for listening to AnimationInterface
@@ -253,9 +253,9 @@
     /**
      * \brief Helper function to set Constant Position for a given node
      * \param n Ptr to the node
-     * \param x X co-ordinate of the node
-     * \param y Y co-ordinate of the node
-     * \param z Z co-ordinate of the node
+     * \param x X coordinate of the node
+     * \param y Y coordinate of the node
+     * \param z Z coordinate of the node
      *
      */
     static void SetConstantPosition(Ptr<Node> n, double x, double y, double z = 0);
@@ -286,6 +286,15 @@
 
     /**
      * \brief Helper function to update the size of a node
+     * \param n Ptr to the node
+     * \param width Width of the node
+     * \param height Height of the node
+     *
+     */
+    void UpdateNodeSize(Ptr<Node> n, double width, double height);
+
+    /**
+     * \brief Helper function to update the size of a node
      * \param nodeId Id of the node
      * \param width Width of the node
      * \param height Height of the node
@@ -325,8 +334,8 @@
     /**
      * \brief Helper function to set the background image
      * \param fileName File name of the background image
-     * \param x X co-ordinate of the image
-     * \param y Y co-ordinate of the image
+     * \param x X coordinate of the image
+     * \param y Y coordinate of the image
      * \param scaleX X scale of the image
      * \param scaleY Y scale of the image
      * \param opacity Opacity of the background: A value between 0.0 and 1.0. 0.0 is transparent,
@@ -373,7 +382,7 @@
      *
      * \returns true if AnimationInterface was started
      */
-    bool IsStarted();
+    bool IsStarted() const;
 
     /**
      * \brief Do not trace packets. This helps reduce the trace file size if AnimationInterface is
@@ -396,7 +405,7 @@
      *
      * \returns Number of packets recorded in the current trace file
      */
-    uint64_t GetTracePktCount();
+    uint64_t GetTracePktCount() const;
 
     /**
      *
@@ -465,27 +474,27 @@
     };
 
     /// RGB structure
-    typedef struct
+    struct Rgb
     {
         uint8_t r; ///< r
         uint8_t g; ///< g
         uint8_t b; ///< b
-    } Rgb;         ///< RGB structure
+    };             ///< RGB structure
 
     /// P2pLinkNodeIdPair structure
-    typedef struct
+    struct P2pLinkNodeIdPair
     {
         uint32_t fromNode; ///< from node
         uint32_t toNode;   ///< to node
-    } P2pLinkNodeIdPair;   ///< P2P link node id pair
+    };                     ///< P2P link node id pair
 
     /// LinkProperties structure
-    typedef struct
+    struct LinkProperties
     {
         std::string fromNodeDescription; ///< from node description
         std::string toNodeDescription;   ///< to node description
         std::string linkDescription;     ///< link description
-    } LinkProperties;                    ///< link properties
+    };                                   ///< link properties
 
     /// LinkPairCompare structure
     struct LinkPairCompare
@@ -514,21 +523,21 @@
     };
 
     /// Ipv4RouteTrackElement structure
-    typedef struct
+    struct Ipv4RouteTrackElement
     {
         std::string destination; ///< destination
         uint32_t fromNodeId;     ///< from node ID
-    } Ipv4RouteTrackElement;     ///< IPv4 route track element
+    };                           ///< IPv4 route track element
 
     /// Ipv4RoutePathElement structure
-    typedef struct
+    struct Ipv4RoutePathElement
     {
         uint32_t nodeId;     ///< node ID
         std::string nextHop; ///< next hop
-    } Ipv4RoutePathElement;  ///< IPv4 route path element
+    };                       ///< IPv4 route path element
 
     /// ProtocolType enumeration
-    typedef enum
+    enum ProtocolType
     {
         UAN,
         LTE,
@@ -537,14 +546,14 @@
         CSMA,
         LRWPAN,
         WAVE
-    } ProtocolType;
+    };
 
     /// NodeSize structure
-    typedef struct
+    struct NodeSize
     {
         double width;  ///< width
         double height; ///< height
-    } NodeSize;        ///< node size
+    };                 ///< node size
 
     typedef std::map<P2pLinkNodeIdPair, LinkProperties, LinkPairCompare>
         LinkPropertiesMap;                                       ///< LinkPropertiesMap typedef
@@ -618,7 +627,7 @@
     bool m_enablePacketMetadata;           ///< enable packet metadata
     Time m_startTime;                      ///< start time
     Time m_stopTime;                       ///< stop time
-    uint64_t m_maxPktsPerFile;             ///< maximum pakets per file
+    uint64_t m_maxPktsPerFile;             ///< maximum packets per file
     std::string m_originalFileName;        ///< original file name
     Time m_routingStopTime;                ///< routing stop time
     std::string m_routingFileName;         ///< routing file name
@@ -1039,7 +1048,7 @@
      * \param tx the transmit device
      * \param rx the receive device
      * \param txTime the transmit time
-     * \param rxTime the reeive time
+     * \param rxTime the receive time
      */
     void DevTxTrace(std::string context,
                     Ptr<const Packet> p,
@@ -1492,7 +1501,6 @@
  * When Anim receives a Tx Notification we tag the packet with a unique global uint64_t identifier
  * before recording Tx information
  * When Anim receives Rx notifications the tag is used to retrieve Tx information recorded earlier
- *
  */
 
 class AnimByteTag : public Tag
@@ -1501,56 +1509,48 @@
     /**
      * \brief Get Type Id
      * \returns Type Id
-     *
      */
     static TypeId GetTypeId();
 
     /**
      * \brief Get Instance Type Id
      * \returns Type Id
-     *
      */
     TypeId GetInstanceTypeId() const override;
 
     /**
      * \brief Get Serialized Size
      * \returns Serialized Size (i.e size of uint64_t)
-     *
      */
     uint32_t GetSerializedSize() const override;
 
     /**
      * \brief Serialize function
      * \param i Tag Buffer
-     *
      */
     void Serialize(TagBuffer i) const override;
 
     /**
      * \brief Deserialize function
      * \param i Tag Buffer
-     *
      */
     void Deserialize(TagBuffer i) override;
 
     /**
      * \brief Print tag info
      * \param os Reference of ostream object
-     *
      */
     void Print(std::ostream& os) const override;
 
     /**
      * \brief Set global Uid in tag
      * \param AnimUid global Uid
-     *
      */
     void Set(uint64_t AnimUid);
 
     /**
      * \brief Get Uid in tag
      * \returns Uid in tag
-     *
      */
     uint64_t Get() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/_required_netanim_version.py ns-3.38/src/netanim/_required_netanim_version.py
--- ns-3.37/src/netanim/_required_netanim_version.py	2022-11-01 17:37:24.683395600 -0700
+++ ns-3.38/src/netanim/_required_netanim_version.py	2023-03-16 20:54:23.796869000 -0700
@@ -6,4 +6,4 @@
 # on 'git describe --tags' command.  Example, if the latest release was 3.108,
 # and 'git describe --tags' reports "netanim-3.108-6-g8e7c0a9", then write the
 # version string below as 'netanim-3.108.post6+ng8e7c0a9'
-__required_netanim_version__ = 'netanim-3.108'
+__required_netanim_version__ = 'netanim-3.109'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/netanim/test/netanim-test.cc ns-3.38/src/netanim/test/netanim-test.cc
--- ns-3.37/src/netanim/test/netanim-test.cc	2022-11-01 17:37:24.687395600 -0700
+++ ns-3.38/src/netanim/test/netanim-test.cc	2023-03-16 20:54:23.804869200 -0700
@@ -35,12 +35,12 @@
 
 /**
  * \ingroup netanim
+ * \ingroup tests
  * \defgroup netanim-test animation module tests
  */
 
 /**
  * \ingroup netanim-test
- * \ingroup tests
  *
  * \brief Abstract Animation Interface Test Case
  */
@@ -112,7 +112,6 @@
 
 /**
  * \ingroup netanim-test
- * \ingroup tests
  *
  * \brief Animation Interface Test Case
  */
@@ -181,7 +180,6 @@
 
 /**
  * \ingroup netanim-test
- * \ingroup tests
  *
  * \brief Animation Remaining Energy Test Case
  */
@@ -243,7 +241,6 @@
 
 /**
  * \ingroup netanim-test
- * \ingroup tests
  *
  * \brief Animation Interface Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/CMakeLists.txt ns-3.38/src/network/CMakeLists.txt
--- ns-3.37/src/network/CMakeLists.txt	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/CMakeLists.txt	2023-03-16 20:54:23.804869200 -0700
@@ -68,6 +68,7 @@
     utils/simple-channel.cc
     utils/simple-net-device.cc
     utils/sll-header.cc
+    utils/timestamp-tag.cc
 )
 
 set(header_files
@@ -146,6 +147,7 @@
     utils/simple-channel.h
     utils/simple-net-device.h
     utils/sll-header.h
+    utils/timestamp-tag.h
 )
 
 build_lib(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/examples/lollipop-comparisions.cc ns-3.38/src/network/examples/lollipop-comparisions.cc
--- ns-3.37/src/network/examples/lollipop-comparisions.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/examples/lollipop-comparisions.cc	2023-03-16 20:54:23.804869200 -0700
@@ -56,4 +56,6 @@
         }
         std::cout << std::endl;
     }
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/helper/application-container.cc ns-3.38/src/network/helper/application-container.cc
--- ns-3.37/src/network/helper/application-container.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/helper/application-container.cc	2023-03-16 20:54:23.804869200 -0700
@@ -89,7 +89,7 @@
 }
 
 void
-ApplicationContainer::Start(Time start)
+ApplicationContainer::Start(Time start) const
 {
     for (Iterator i = Begin(); i != End(); ++i)
     {
@@ -99,7 +99,7 @@
 }
 
 void
-ApplicationContainer::StartWithJitter(Time start, Ptr<RandomVariableStream> rv)
+ApplicationContainer::StartWithJitter(Time start, Ptr<RandomVariableStream> rv) const
 {
     for (Iterator i = Begin(); i != End(); ++i)
     {
@@ -111,7 +111,7 @@
 }
 
 void
-ApplicationContainer::Stop(Time stop)
+ApplicationContainer::Stop(Time stop) const
 {
     for (Iterator i = Begin(); i != End(); ++i)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/helper/application-container.h ns-3.38/src/network/helper/application-container.h
--- ns-3.37/src/network/helper/application-container.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/helper/application-container.h	2023-03-16 20:54:23.804869200 -0700
@@ -140,7 +140,7 @@
      * Applications can be retrieved from the container in two ways.  First,
      * directly by an index into the container, and second, using an iterator.
      * This method is used in the direct method and is used to retrieve the
-     * indexed Ptr<Appliation>.
+     * indexed Ptr<Application>.
      *
      * \code
      *   uint32_t nApplications = container.GetN ();
@@ -180,8 +180,8 @@
     void Add(std::string name);
 
     /**
-     * \brief Arrange for all of the Applications in this container to Start()
-     * at the Time given as a parameter.
+     * \brief Start all of the Applications in this container at the start time
+     * given as a parameter.
      *
      * All Applications need to be provided with a starting simulation time and
      * a stopping simulation time.  The ApplicationContainer is a convenient
@@ -189,24 +189,24 @@
      * up and start doing their thing (Start) at a common time.
      *
      * This method simply iterates through the contained Applications and calls
-     * their Start() methods with the provided Time.
+     * their Application::SetStartTime() methods with the provided Time.
      *
      * \param start The Time at which each of the applications should start.
      */
-    void Start(Time start);
+    void Start(Time start) const;
 
     /**
      * \brief Start all of the Applications in this container at the start time
      * given as a parameter, plus some jitter.
      *
      * This method iterates through the contained Applications and calls
-     * their Start() methods with the provided start Time, plus a jitter value
-     * drawn from the provided random variable.
+     * their Application::SetStartTime() methods with the provided start Time, plus
+     * a jitter value drawn from the provided random variable.
      *
      * \param start The Time at which each of the applications should start.
      * \param rv The random variable that adds jitter (units of seconds)
      */
-    void StartWithJitter(Time start, Ptr<RandomVariableStream> rv);
+    void StartWithJitter(Time start, Ptr<RandomVariableStream> rv) const;
 
     /**
      * \brief Arrange for all of the Applications in this container to Stop()
@@ -218,11 +218,11 @@
      * down and stop doing their thing (Stop) at a common time.
      *
      * This method simply iterates through the contained Applications and calls
-     * their Stop() methods with the provided Time.
+     * their Application::SetStopTime() methods with the provided Time.
      *
      * \param stop The Time at which each of the applications should stop.
      */
-    void Stop(Time stop);
+    void Stop(Time stop) const;
 
   private:
     std::vector<Ptr<Application>> m_applications; //!< Applications smart pointers
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/helper/delay-jitter-estimation.cc ns-3.38/src/network/helper/delay-jitter-estimation.cc
--- ns-3.37/src/network/helper/delay-jitter-estimation.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/helper/delay-jitter-estimation.cc	2023-03-16 20:54:23.804869200 -0700
@@ -21,120 +21,28 @@
 
 #include "ns3/simulator.h"
 #include "ns3/string.h"
-#include "ns3/tag.h"
+#include "ns3/timestamp-tag.h"
 
 namespace ns3
 {
 
-/**
- * Tag to perform Delay and Jitter estimations
- *
- * The tag holds the packet's creation timestamp
- */
-class DelayJitterEstimationTimestampTag : public Tag
-{
-  public:
-    DelayJitterEstimationTimestampTag();
-
-    /**
-     * \brief Get the type ID.
-     * \return the object TypeId
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-
-    uint32_t GetSerializedSize() const override;
-    void Serialize(TagBuffer i) const override;
-    void Deserialize(TagBuffer i) override;
-    void Print(std::ostream& os) const override;
-
-    /**
-     * \brief Get the Transmission time stored in the tag
-     * \return the transmission time
-     */
-    Time GetTxTime() const;
-
-  private:
-    Time m_creationTime; //!< The time stored in the tag
-};
-
-DelayJitterEstimationTimestampTag::DelayJitterEstimationTimestampTag()
-    : m_creationTime(Simulator::Now())
-{
-}
-
-TypeId
-DelayJitterEstimationTimestampTag::GetTypeId()
-{
-    static TypeId tid =
-        TypeId("anon::DelayJitterEstimationTimestampTag")
-            .SetParent<Tag>()
-            .SetGroupName("Network")
-            .AddConstructor<DelayJitterEstimationTimestampTag>()
-            .AddAttribute("CreationTime",
-                          "The time at which the timestamp was created",
-                          TimeValue(Time(0)),
-                          MakeTimeAccessor(&DelayJitterEstimationTimestampTag::m_creationTime),
-                          MakeTimeChecker());
-    return tid;
-}
-
-TypeId
-DelayJitterEstimationTimestampTag::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
-uint32_t
-DelayJitterEstimationTimestampTag::GetSerializedSize() const
-{
-    return 8;
-}
-
-void
-DelayJitterEstimationTimestampTag::Serialize(TagBuffer i) const
-{
-    i.WriteU64(m_creationTime.GetTimeStep());
-}
-
-void
-DelayJitterEstimationTimestampTag::Deserialize(TagBuffer i)
-{
-    m_creationTime = TimeStep(i.ReadU64());
-}
-
-void
-DelayJitterEstimationTimestampTag::Print(std::ostream& os) const
-{
-    os << "CreationTime=" << m_creationTime;
-}
-
-Time
-DelayJitterEstimationTimestampTag::GetTxTime() const
-{
-    return m_creationTime;
-}
-
 DelayJitterEstimation::DelayJitterEstimation()
-    : m_jitter(Time(0)),
-      m_transit(Time(0))
 {
 }
 
 void
 DelayJitterEstimation::PrepareTx(Ptr<const Packet> packet)
 {
-    DelayJitterEstimationTimestampTag tag;
+    TimestampTag tag(Simulator::Now());
     packet->AddByteTag(tag);
 }
 
 void
 DelayJitterEstimation::RecordRx(Ptr<const Packet> packet)
 {
-    DelayJitterEstimationTimestampTag tag;
-    bool found;
-    found = packet->FindFirstMatchingByteTag(tag);
-    if (!found)
+    TimestampTag tag;
+
+    if (!packet->FindFirstMatchingByteTag(tag))
     {
         return;
     }
@@ -142,15 +50,14 @@
     // Variable names from
     // RFC 1889 Appendix A.8 ,p. 71,
     // RFC 3550 Appendix A.8, p. 94
-
-    Time r_ts = tag.GetTxTime();
+    Time r_ts = tag.GetTimestamp();
     Time arrival = Simulator::Now();
     Time transit = arrival - r_ts;
     Time delta = transit - m_transit;
     m_transit = transit;
 
     // floating jitter version
-    //  m_jitter += (Abs (delta) - m_jitter) / 16;
+    // m_jitter += (Abs (delta) - m_jitter) / 16;
 
     // int variant
     m_jitter += Abs(delta) - ((m_jitter + TimeStep(8)) / 16);
@@ -166,7 +73,7 @@
 DelayJitterEstimation::GetLastJitter() const
 {
     // floating jitter version
-    // return m_jitter.GetTimeStep ();
+    // return m_jitter.GetTimeStep();
 
     // int variant
     return (m_jitter / 16).GetTimeStep();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/helper/delay-jitter-estimation.h ns-3.38/src/network/helper/delay-jitter-estimation.h
--- ns-3.37/src/network/helper/delay-jitter-estimation.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/helper/delay-jitter-estimation.h	2023-03-16 20:54:23.804869200 -0700
@@ -42,40 +42,44 @@
     DelayJitterEstimation();
 
     /**
-     * \param packet the packet to send over a wire
-     *
      * This method should be invoked once on each packet to
      * record within the packet the tx time which is used upon
      * packet reception to calculate the delay and jitter. The
      * tx time is stored in the packet as an ns3::Tag which means
      * that it does not use any network resources and is not
      * taken into account in transmission delay calculations.
+     *
+     * \param packet the packet to send over a wire
      */
     static void PrepareTx(Ptr<const Packet> packet);
+
     /**
-     * \param packet the packet received
-     *
      * Invoke this method to update the delay and jitter calculations
      * After a call to this method, \ref GetLastDelay and \ref GetLastJitter
      * will return an updated delay and jitter.
+     *
+     * \param packet the packet received
      */
     void RecordRx(Ptr<const Packet> packet);
 
     /**
-     * \returns the updated delay.
+     * Get the Last Delay object.
+     *
+     * \return the updated delay.
      */
     Time GetLastDelay() const;
+
     /**
      * The jitter is calculated using the \RFC{1889} (RTP) jitter
      * definition.
      *
-     * \returns the updated jitter.
+     * \return the updated jitter.
      */
     uint64_t GetLastJitter() const;
 
   private:
-    Time m_jitter;  //!< Jitter estimation
-    Time m_transit; //!< Relative transit time for the previous packet
+    Time m_jitter{0};  //!< Jitter estimation
+    Time m_transit{0}; //!< Relative transit time for the previous packet
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/helper/trace-helper.cc ns-3.38/src/network/helper/trace-helper.cc
--- ns-3.37/src/network/helper/trace-helper.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/helper/trace-helper.cc	2023-03-16 20:54:23.804869200 -0700
@@ -79,7 +79,7 @@
 PcapHelper::GetFilenameFromDevice(std::string prefix, Ptr<NetDevice> device, bool useObjectNames)
 {
     NS_LOG_FUNCTION(prefix << device << useObjectNames);
-    NS_ABORT_MSG_UNLESS(prefix.size(), "Empty prefix string");
+    NS_ABORT_MSG_UNLESS(!prefix.empty(), "Empty prefix string");
 
     std::ostringstream oss;
     oss << prefix << "-";
@@ -95,7 +95,7 @@
         devicename = Names::FindName(device);
     }
 
-    if (nodename.size())
+    if (!nodename.empty())
     {
         oss << nodename;
     }
@@ -106,7 +106,7 @@
 
     oss << "-";
 
-    if (devicename.size())
+    if (!devicename.empty())
     {
         oss << devicename;
     }
@@ -127,7 +127,7 @@
                                          bool useObjectNames)
 {
     NS_LOG_FUNCTION(prefix << object << interface << useObjectNames);
-    NS_ABORT_MSG_UNLESS(prefix.size(), "Empty prefix string");
+    NS_ABORT_MSG_UNLESS(!prefix.empty(), "Empty prefix string");
 
     std::ostringstream oss;
     oss << prefix << "-";
@@ -143,11 +143,11 @@
         nodename = Names::FindName(node);
     }
 
-    if (objname.size())
+    if (!objname.empty())
     {
         oss << objname;
     }
-    else if (nodename.size())
+    else if (!nodename.empty())
     {
         oss << nodename;
     }
@@ -216,7 +216,7 @@
                                         bool useObjectNames)
 {
     NS_LOG_FUNCTION(prefix << device << useObjectNames);
-    NS_ABORT_MSG_UNLESS(prefix.size(), "Empty prefix string");
+    NS_ABORT_MSG_UNLESS(!prefix.empty(), "Empty prefix string");
 
     std::ostringstream oss;
     oss << prefix << "-";
@@ -232,7 +232,7 @@
         devicename = Names::FindName(device);
     }
 
-    if (nodename.size())
+    if (!nodename.empty())
     {
         oss << nodename;
     }
@@ -243,7 +243,7 @@
 
     oss << "-";
 
-    if (devicename.size())
+    if (!devicename.empty())
     {
         oss << devicename;
     }
@@ -264,7 +264,7 @@
                                                bool useObjectNames)
 {
     NS_LOG_FUNCTION(prefix << object << interface << useObjectNames);
-    NS_ABORT_MSG_UNLESS(prefix.size(), "Empty prefix string");
+    NS_ABORT_MSG_UNLESS(!prefix.empty(), "Empty prefix string");
 
     std::ostringstream oss;
     oss << prefix << "-";
@@ -280,11 +280,11 @@
         nodename = Names::FindName(node);
     }
 
-    if (objname.size())
+    if (!objname.empty())
     {
         oss << objname;
     }
-    else if (nodename.size())
+    else if (!nodename.empty())
     {
         oss << nodename;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/address.h ns-3.38/src/network/model/address.h
--- ns-3.37/src/network/model/address.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/address.h	2023-03-16 20:54:23.804869200 -0700
@@ -86,6 +86,14 @@
  * }
  * \endcode
  *
+ * To convert a specific Address T (e.g., Ipv6Address) to and from an Address type,
+ * a class must implement three public functions:
+ * \code
+ * static T ConvertFrom(const Address& address);
+ * Address ConvertTo() const;
+ * operator Address() const;
+ * \endcode
+ *
  * \see attribute_Address
  */
 class Address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/application.h ns-3.38/src/network/model/application.h
--- ns-3.37/src/network/model/application.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/application.h	2023-03-16 20:54:23.804869200 -0700
@@ -74,7 +74,7 @@
      *        relative to the current simulation time.
      *
      * Applications start at various times in the simulation scenario.
-     * The Start method specifies when the application should be
+     * This method specifies when the application should be
      * started.  The application subclasses should override the
      * private "StartApplication" method defined below, which is called at the
      * time specified, to cause the application to begin.
@@ -87,7 +87,7 @@
      *        current simulation time.
      *
      * Once an application has started, it is sometimes useful
-     * to stop the application.  The Stop method specifies when an
+     * to stop the application.  This method specifies when an
      * application is to stop.  The application subclasses should override
      * the private StopApplication method, to be notified when that
      * time has come.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/buffer.h ns-3.38/src/network/model/buffer.h
--- ns-3.37/src/network/model/buffer.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/buffer.h	2023-03-16 20:54:23.804869200 -0700
@@ -802,9 +802,9 @@
         ~LocalStaticDestructor();
     };
 
-    static uint32_t g_maxSize;                                   //!< Max observed data size
-    static FreeList* g_freeList;                                 //!< Buffer data container
-    static struct LocalStaticDestructor g_localStaticDestructor; //!< Local static destructor
+    static uint32_t g_maxSize;                            //!< Max observed data size
+    static FreeList* g_freeList;                          //!< Buffer data container
+    static LocalStaticDestructor g_localStaticDestructor; //!< Local static destructor
 #endif
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/byte-tag-list.cc ns-3.38/src/network/model/byte-tag-list.cc
--- ns-3.37/src/network/model/byte-tag-list.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/byte-tag-list.cc	2023-03-16 20:54:23.804869200 -0700
@@ -92,7 +92,7 @@
 ByteTagList::Iterator::Next()
 {
     NS_ASSERT(HasNext());
-    struct Item item = Item(TagBuffer(m_current + 16, m_end));
+    Item item = Item(TagBuffer(m_current + 16, m_end));
     item.tid.SetUid(m_nextTid);
     item.size = m_nextSize;
     item.start = std::max(m_nextStart, m_offsetStart);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/nix-vector.h ns-3.38/src/network/model/nix-vector.h
--- ns-3.37/src/network/model/nix-vector.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/nix-vector.h	2023-03-16 20:54:23.804869200 -0700
@@ -34,7 +34,7 @@
  *
  * This data structure holds a vector of "neighbor-indexes" for
  * a simulation specific routing protocol, nix-vector routing.
- * Theses neighbor-indexes correspond to the net-device which a
+ * These neighbor-indexes correspond to the net-device which a
  * node should use to route a packet.  A nix-vector is built
  * (or fetched from a cache) on-demand. The nix-vector is
  * transmitted with the packet, and along each hop of the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/packet-metadata.h ns-3.38/src/network/model/packet-metadata.h
--- ns-3.37/src/network/model/packet-metadata.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/packet-metadata.h	2023-03-16 20:54:23.804869200 -0700
@@ -91,7 +91,12 @@
             PAYLOAD, //!< Payload
             HEADER,  //!< Header
             TRAILER  //!< Trailer
-        } type;      //!< metadata type
+        };
+
+        /**
+         * metadata type
+         */
+        ItemType type;
 
         /**
          * true: this is a fragmented header, trailer, or, payload.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/model/socket.h ns-3.38/src/network/model/socket.h
--- ns-3.37/src/network/model/socket.h	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/model/socket.h	2023-03-16 20:54:23.808869100 -0700
@@ -180,7 +180,7 @@
      *        completed. The callback is passed  back a pointer to
      *        the same socket object.
      * \param connectionFailed this callback is invoked when the
-     *        connection request initiated by the user is unsuccessfully
+     *        connection request initiated by the user is unsuccessfuly
      *        completed. The callback is passed back a pointer to the
      *        same socket object.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/test/buffer-test.cc ns-3.38/src/network/test/buffer-test.cc
--- ns-3.37/src/network/test/buffer-test.cc	2022-11-01 17:37:24.691395800 -0700
+++ ns-3.38/src/network/test/buffer-test.cc	2023-03-16 20:54:23.808869100 -0700
@@ -291,8 +291,7 @@
     i.Prev(100);
     i.WriteU8(1, 100);
 
-    /// \internal
-    /// See \bugid{54}
+    // See \bugid{54}
     {
         const uint32_t actualSize = 72602;
         const uint32_t chunkSize = 67624;
@@ -354,7 +353,7 @@
     i.Write(buffer.Begin(), buffer.End());
     ENSURE_WRITTEN_BYTES(other, 9, 0x1, 0x2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3, 0x4);
 
-    /// \internal See \bugid{1001}
+    // See \bugid{1001}
     std::string ct("This is the next content of the buffer.");
     buffer = Buffer();
     buffer.AddAtStart(ct.size());
@@ -376,7 +375,7 @@
     }
     free(cBuf);
 
-    /// \internal See \bugid{2044}  Will not pass without bug2044 fix.
+    // See \bugid{2044}  Will not pass without bug2044 fix.
     buffer = Buffer(1);
     buffer.AddAtEnd(2);
     i = buffer.Begin();
